/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                                /*----------------*
                                 *   CPPLMEN7.C   *
                                 * Menu manager7  *
                                 *----------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu7,return1;
 extern int colour1,colour2,colour3,colour4,colour5,returning;
 extern unsigned char c0,c1,trashcan[];

 /*----------------------*
  * CHOICE DISPLAY HELP7 *
  *----------------------*/
  void choice_display_help7()
    {
      /* We display the help that concerns the line on */
      /* which is the menu cursor (in red).            */
      if(menu7==1){
	/*  */
        display_help("MENU7   ",65,2,1);     restore_help_screen();
      }
      if(menu7==2){
	/*  */
        display_help("MENU7   ",66,3,1);     restore_help_screen();
      }
      if(menu7==3){
	/*  */
        display_help("MENU7   ",67,4,1);     restore_help_screen();
      }
      if(menu7==4){
	/*  */
        display_help("MENU7   ",68,5,1);     restore_help_screen();
      }
      if(menu7==5){
	/*  */
        display_help("MENU7   ",69,6,1);     restore_help_screen();
      }
      if(menu7==6){
	/*  */
        display_help("MENU7   ",70,7,1);     restore_help_screen();
      }
      if(menu7==7){
        /* available */
        display_help("MENU7   ",71,8,1);     restore_help_screen();
      }
      if(menu7==8){
	/*  */
        display_help("MENU7   ",72,9,1);     restore_help_screen();
      }
      if(menu7==9){
	/*  */
        display_help("MENU7   ",73,10,1);    restore_help_screen();
      }
      if(menu7==10){
	/*  */
        display_help("MENU7   ",74,11,1);    restore_help_screen();
      }
    }
 /*----------------*
  * GET THE MOUSE7 *
  *----------------*/
  int get_the_mouse7()
    {
      /* If we choose with the mouse */
      /* Only  available for menu 1  */
      if(ym==1){
        /* We clicked on the first line, certainly */
        /* To change of menu.                      */
        x=get_the_mouse0();
	menu0=x;                       return(-2);
      }
      if((xm>46)&&(xm<63)){
	if(ym==3){
	  /*  */
	  menu7=1;	               return(1);
	}
	if(ym==4){
	  /*  */
	  menu7=2;                     return(1);
	}
	if(ym==5){
	  /*  */
	  menu7=3;                     return(1);
	}
	if(ym==6){
	  /*  */
	  menu7=4;                     return(1);
	}
	if(ym==7){
	  /*  */
	  menu7=5;                     return(1);
	}
	if(ym==8){
	  /*  */
	  menu7=6;                     return(1);
	}
	if(ym==9){
	  /*  */
	  menu7=7;                     return(1);
	}
	if(ym==10){
	  /*  */
	  menu7=8;                     return(1);
	}
	if(ym==11){
	  /*  */
	  menu7=9;                     return(1);
	}
	if(ym==12){
	  /*  */
	  menu7=10;                    return(1);
	}
      }
      /* If we clicked outside the menu zone            */
      /* we want to erase the menu and return to menu 0 */
      /*  */
      menu0=0;                         return(-2);
    }
 /*--------------*
  * MENU CHOICE7 *
  *--------------*/
  int menu_choice7()
    {
      returning=wait_for_a_key();
      /* Else we pressed a keyboard key                            */
      /* Cf CPPLTC2.C for the keyboard test and the returned codes */
      if(returning==-1){
        /* <Esc> we want to go back to menu0 */
	menu0=0;                       return(-2);
      }
      if(returning==40){
        /* <Enter> execute the command */
	return(1);
      }
      if(returning==100){
        /* We pressed a mouse button */
        m=get_the_mouse7();  return(m);
      }
      /* The key letters depends on the menu  */

      /* So the below returns need to be modified */
      if(returning==24){
	/* <O> <o>  */
	menu7=1;                       return(1);
      }
      if(returning==23){
	/* <N> <n>  */
	menu7=2;                       return(1);
      }
      if(returning==28){
	/* <S> <s>  */
	menu7=3;                       return(1);
      }
      if(returning==13){
	/* <D> <d>  */
	menu7=5;                       return(1);
      }
      if(returning==27){
	/* <R> <r>  */
	menu7=6;                       return(1);
      }
      if(returning==18){
	/* <I> <i>  */
	menu7=7;                       return(1);
      }
      if(returning==15){
	/* <F> <f>  */
	menu7=8;                       return(1);
      }
      if(returning==26){
	/* <Q> <q>  */
	menu7=10;	               return(1);
      }
      /* For the 2-bytes coded keys, this is the second byte */
      if(returning==59){
         /* Function key <F1> = help */
	 return(59);
      }
      if(returning>100){
        /* We pressed Alt + another key to get a menu */
        c1=returning-100;                 k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if((returning==77)||(returning==75)){
        /* Left or Right arrow to change of menu */
        c1=returning;                             k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if(returning==72){
        /* Up arrow */
	if(menu7>1)                    menu7--;
	else                           menu7=10;
	return(0);
      }
      if(returning==80){
        /* Down arrow */
	if(menu7<10)                   menu7++;
	else                           menu7=1;
	return(0);
      }
      /* Else we return 0 = no choice */
      return(0);
    }
 /*--------------------*
  * DISPLAY LINE menu7 *
  *--------------------*/
  void display_menu_line7()
    {
      /* First we display the chosen menu0 */
      textattr(colour5);
      gotoxy(49,1);                    cputs("  Menu7  ");
      /* Same thing for the selected line */
      if(menu7==1){
	gotoxy(47,3);                  cputs("                ");
      }
      if(menu7==2){
	gotoxy(47,4);                  cputs("                ");
      }
      if(menu7==3){
	gotoxy(47,5);                  cputs("                ");
      }
      if(menu7==4){
	gotoxy(47,6);                  cputs("                ");
      }
      if(menu7==5){
	gotoxy(47,7);                  cputs("                ");
      }
      if(menu7==6){
	gotoxy(47,8);                  cputs("                ");
      }
      if(menu7==7){
	gotoxy(47,9);                  cputs("                ");
      }
      if(menu7==8){
	gotoxy(47,10);                 cputs("                ");
      }
      if(menu7==9){
	gotoxy(47,11);                 cputs("                ");
      }
      if(menu7==10){
	gotoxy(47,12);                 cputs("                ");
      }
    }
 /*----------------------*
  * DISPLAY KEY LETTER 7 *
  *----------------------*/
  void display_key_letter7()
    {
      textattr(116);
      gotoxy(48,3);                   cputs(" ");
      gotoxy(48,4);                   cputs(" ");
      gotoxy(48,5);                   cputs(" ");
      gotoxy(48,6);                   cputs(" ");
      gotoxy(48,7);                   cputs(" ");
      gotoxy(48,8);                   cputs(" ");
      gotoxy(48,9);                   cputs(" ");
      gotoxy(48,10);                  cputs(" ");
      gotoxy(48,11);                  cputs(" ");
      gotoxy(48,12);                  cputs(" ");
    }
 /*---------------*
  * DISPLAY menu7 *
  *---------------*/
  void display_menu7()
    {
      /* To avoid the trace of the previous mouse position */
      /* we hide it during the display,                    */
      /* and show it when the line has been displayed.     */
      hide_the_mouse();               textattr(colour2);
      gotoxy(45,2);                    cputs(" Ŀ ");
      gotoxy(45,3);                    cputs("                  ");
      gotoxy(45,4);                    cputs("                  ");
      gotoxy(45,5);                    cputs("                  ");
      gotoxy(45,6);                    cputs("                  ");
      gotoxy(45,7);                    cputs("                  ");
      gotoxy(45,8);                    cputs("                  ");
      gotoxy(45,9);                    cputs("                  ");
      gotoxy(45,10);                   cputs("                  ");
      gotoxy(45,11);                   cputs("                  ");
      gotoxy(45,12);                   cputs("                  ");
      gotoxy(45,13);                   cputs("  ");
      display_key_letter7();           display_menu_line7();
      show_the_mouse();
    }
 /*----------------*
  * MENU MANAGER 7 *
  *----------------*/
  int menu_manager7()
    {
      restore_screen();                return1=0;
      while(1){
        display_menu7();               return1=menu_choice7();
        if(return1==-2)                return(-2);
        if(return1==-1)                return(-1);
        if(return1==22)                choice_display_help7();
        display_menu7();
        if(return1==1){
          /* We execute the selected function */
	  if(menu7==10){
            /* We want to quit the sub-program */
	    return(-1);
	  }
	  if(menu7==1){
	    /*  */

	  }
	  if(menu7==2){
	    /*  */

	  }
	  if(menu7==3){
	    /*  */

	  }
	  if(menu7==4){
	    /*  */

	  }
	  if(menu7==5){
	    /*  */

	  }
	  if(menu7==6){
	    /*  */

	  }
	  if(menu7==7){
	    /*  */

	  }
	  if(menu7==8){
	    /*  */

	  }
	  if(menu7==9){
	    /*  */

	  }
	}
      }
    }
/* End of the Module *//*----------------*/
